Index: /trunk/src/lib/collision_detection/aabb_tree_node.cc
===================================================================
--- /trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 9493)
+++ /trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 9494)
@@ -66,4 +66,6 @@
 {
   this->depth = depth;
+
+  this->init();
 }
 
@@ -87,10 +89,4 @@
 
   this->owner = NULL;
-
-  /* debug ids */
-  if( this->nodePrev)
-    this->treeIndex = 100 * this->depth + this->nodePrev->getID();
-  else
-    this->treeIndex = 0;
 }
 
Index: /trunk/src/lib/network/Makefile.am
===================================================================
--- /trunk/src/lib/network/Makefile.am	(revision 9493)
+++ /trunk/src/lib/network/Makefile.am	(revision 9494)
@@ -28,7 +28,8 @@
 		      proxy/network_settings.cc \
 		      \
-				  monitor/connection_monitor.cc \
+		      monitor/connection_monitor.cc \
 		      monitor/network_monitor.cc \
 		      monitor/network_node.cc \
+		      monitor/network_stats_widget.cc \
 		      \
 		      synchronizeable_var/synchronizeable_var.cc \
@@ -77,7 +78,8 @@
 		proxy/network_settings.cc \
 		\
-                monitor/connection_monitor.h \
-                monitor/network_monitor.h \
-                monitor/network_node.h \
+		monitor/connection_monitor.h \
+		monitor/network_monitor.h \
+		monitor/network_node.h \
+		monitor/network_stats_widget.h \
 		\
 		synchronizeable_var/synchronizeable_var.h \
Index: /trunk/src/lib/network/README.NETWORK
===================================================================
--- /trunk/src/lib/network/README.NETWORK	(revision 9493)
+++ /trunk/src/lib/network/README.NETWORK	(revision 9494)
@@ -1,2 +1,17 @@
+
+
+
+WORKING_STACK:
+==============
+ - it works to connecto to a master server which is connected to a proxy itself
+
+
+
+UNSOLVED:
+=========
+ - what if the proxy server gets a new client and wants to add it to the game? There are some problems waiting in the network game manager
+ - actualy the whole message sending system won't work in this network topic. proxys have to relay messages to clients
+ - the clients cant get its ip in the handleHandshakes without throuwing sigseg
+
 
 
@@ -8,13 +23,51 @@
 
 UserId:
+=======
 containing the id of a user (==client). This id must be unique within a orxonox network its used especialy in the NetworkStream for node identification and also in the Synchronizeable base class for permissions checking (PERMISSION_OWNER)
-WARNING:
-There is some correlation between userids and the maxplayer, do not touch this.
+
+the connections belonging tu toe userId's are stored in the NetworkStream::peers std::map. As a keyvalue the userId's are used. Therefore the usage of this peers map is very delicate. Don't ever try to add anything you are not sure about the id stuff.
+
+There are some reserved id's, don't mess with them:
+0 :                  Master Server
+1 :                  First Proxy Server
+2 :                  Second Proxy Server
+3 :                  Third Proxy Server
+4 :                  Fourth Proxy Server
+.
+.
+.
+NET_MAX_PROXY        The maximal number of proxy servers
+NET_MAX... + 1       First Client
+NET_MAX... + 2       Second Client
+.
+.
+.
+NET_MAX_CONNECTION   Last client
+
+The proxy server ids are assigned as stated in the data/trunk/config/network_settings.conf, the first proxy server in the list gets the id NET_ID_PROXY_01 and so on.
+
 
 
 uniqueId:
+=========
 uniqueId is an id (unique :D) for each synchronizeable to be identified in a network. the number space for uniqueIds goes from 0 to maxplayers - 1
 
 
+permissions:
+============
+Each synchronizeable variable has some write permissions. this permission systems allows to manage which network nodes are able to write the variables.
+PERMISSION_MASTER_SERVER       : only the master server can write this variable
+PERMISSION_PROXY_SERVER        : only the proxy server can write this variable
+PERMISSION_OWNER               : only the owner can write this variable
+PERMISSION_ALL                 : all clients can write this variable
+
+
+
+
+
 NetworkStream PeerInfo list: (peers)
+=====================================
 The network node with the offset 0 is always the server to which the client must connect to (in case there are connections to other hosts at the same time).
+
+
+
Index: /trunk/src/lib/network/handshake.cc
===================================================================
--- /trunk/src/lib/network/handshake.cc	(revision 9493)
+++ /trunk/src/lib/network/handshake.cc	(revision 9494)
@@ -76,5 +76,5 @@
   remoteState.orxId = 0;
   remoteState.version = 0;
-  remoteState.nodeType = NET_CLIENT;
+  remoteState.nodeType = NET_UNASSIGNED;
   remoteState.canDel = 0;
 
Index: /trunk/src/lib/network/handshake.h
===================================================================
--- /trunk/src/lib/network/handshake.h	(revision 9493)
+++ /trunk/src/lib/network/handshake.h	(revision 9494)
@@ -49,34 +49,34 @@
     /* functions indicating states of the handshake */
     /** @returns true if the handshake is completed */
-    inline bool completed(){ return localState.completed != 0 && remoteState.completed != 0; }
+    inline bool completed() const { return localState.completed != 0 && remoteState.completed != 0; }
     /** @returns true if no error has occured until now */
-    inline bool ok(){ return localState.error == 0 && remoteState.error == 0; }
+    inline bool ok() const { return localState.error == 0 && remoteState.error == 0; }
     /** stops the handshake and reject the other side with @param reason: string describing the reason */
     inline void doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
     /** @returns true if the handshake is finished and the instances can be deleted */
-    inline bool canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
+    inline bool canDel() const { return localState.canDel == 1 && remoteState.canDel == 1; }
     /** @returns true if the local state can be removed*/
-    inline bool allowDel(){ return localState.canDel == 1; }
+    inline bool allowDel() const { return localState.canDel == 1; }
     /** marks the handshake to be deleted */
-    inline void del(){ localState.canDel = 1; }
+    inline void del() { localState.canDel = 1; }
 
 
     /* the actual informations exchanged in the handshake */
     /** @returns the host id of the remote host */
-    inline int  getHostId(){ return remoteState.hostId; }
+    inline int  getHostId() const { return remoteState.hostId; }
     /** @returns the unique id of the network game manager*/
-    inline int  getNetworkGameManagerId(){ return remoteState.networkManagerId; }
+    inline int  getNetworkGameManagerId() const { return remoteState.networkManagerId; }
     /** @returns the unique id of the message manager */
-    inline int  getMessageManagerId(){ return remoteState.messageManagerId; }
+    inline int  getMessageManagerId() const { return remoteState.messageManagerId; }
     /** @returns the node type of the remote host */
-    inline int getRemoteNodeType() { return this->remoteState.nodeType; }
+    inline int getRemoteNodeType() const { return this->remoteState.nodeType; }
 
     /** sets @param nick the prefereded nick name */
     inline void setPreferedNickName( const std::string & nick ){ localState.preferedNickName = nick; }
     /** @returns the prefered nick name */
-    inline std::string getPreferedNickName(){ return remoteState.preferedNickName; }
+    inline const std::string& getPreferedNickName() const { return remoteState.preferedNickName; }
 
     /** @returns if true the local client should reconnect to a proxy server from the proxy server list */
-    inline bool redirect() { return this->redirectProxy;}
+    inline bool redirect() const  { return this->redirectProxy; }
     /** @param flag: indicating if the client should be redirected */
     inline void setRedirect(bool flag) { if( SharedNetworkData::getInstance()->isClient()) return; this->redirectProxy = (int)flag; }
@@ -85,9 +85,9 @@
     inline void setProxy1Address(IP address) { if( SharedNetworkData::getInstance()->isClient()) return; this->proxy1 = address; }
     /** @returns the address of the proxy server 1 if any */
-    inline IP getProxy1Address() { return this->proxy1; }
+    inline IP getProxy1Address() const { return this->proxy1; }
     /** @param address: the address of the proxy server 2 if any */
     inline void setProxy2Address(IP address) { if( SharedNetworkData::getInstance()->isClient()) return; this->proxy2 = address; }
     /** @returns the address of the proxy server 2 if any */
-    inline IP getProxy2Address() { return this->proxy2; }
+    inline IP getProxy2Address() const { return this->proxy2; }
 
 
Index: /trunk/src/lib/network/ip.cc
===================================================================
--- /trunk/src/lib/network/ip.cc	(revision 9493)
+++ /trunk/src/lib/network/ip.cc	(revision 9494)
@@ -111,8 +111,8 @@
 IP::IP(unsigned int first, unsigned int second, unsigned int third, unsigned int fourth, int port)
 {
-  this->_host = (first << 24) +
-                (second << 16) +
-                (third <<  8) +
-                fourth;
+  this->_host = (fourth << 24) +
+                (third << 16) +
+                (second <<  8) +
+                (first);
   this->_port = port;
 }
@@ -185,7 +185,7 @@
     IPaddress ipaddr;
 
-    SDLNet_ResolveHost(&ipaddr, NULL, 2000);
-
-    return IP(ipaddr.host, port);
+    SDLNet_ResolveHost(&ipaddr, ip.c_str(), port);
+
+    return IP(ipaddr);
   }
   else
@@ -255,20 +255,18 @@
 /**
  * @brief converts a IP into a String (without port).
- * @param ip the IP to put into the string.
+ * @param host the IP to put into the string.
  * @param port -1 if not wanted
  * @return the string of the ip.
  */
-std::string IP::ipToString(int ip, int port)
-{
-  MultiType part0((int) (ip & 0xFF000000) >> 24);
-  MultiType part1((int) (ip & 0x00FF0000) >> 16);
-  MultiType part2((int) (ip & 0x0000FF00) >>  8);
-  MultiType part3((int) (ip & 0x000000FF) );
+std::string IP::ipToString(int host, int port)
+{
+  MultiType part0((int) ((host & 0xFF000000) >> 24));
+  MultiType part1((int) ((host & 0x00FF0000) >> 16));
+  MultiType part2((int) ((host & 0x0000FF00) >>  8));
+  MultiType part3((int) ((host & 0x000000FF) ));
 
   std::string addr = part3.getString() + "." + part2.getString() + "." +
                      part1.getString() + "." + part0.getString();
 
-  if (port != -1)
-    addr += ":" + MultiType(port).getString();
   return addr;
 }
Index: /trunk/src/lib/network/ip.h
===================================================================
--- /trunk/src/lib/network/ip.h	(revision 9493)
+++ /trunk/src/lib/network/ip.h	(revision 9494)
@@ -54,5 +54,5 @@
 
     static std::string ipToString(const IPaddress& ipaddr);
-    static std::string ipToString(int ip, int port = -1);
+    static std::string ipToString(int host, int port = -1);
 
     static void setDefaultPort(int defaultPort);
Index: /trunk/src/lib/network/message_manager.cc
===================================================================
--- /trunk/src/lib/network/message_manager.cc	(revision 9493)
+++ /trunk/src/lib/network/message_manager.cc	(revision 9494)
@@ -320,8 +320,9 @@
     if (
          recieverType == RT_ALL_ME ||
-         recieverType == RT_ALL_NOT_ME ||
+         recieverType == RT_ALL_BUT_ME ||
          recieverType == RT_USER && it->first == reciever ||
          recieverType == RT_NOT_USER && it->first != reciever ||
-         recieverType == RT_SERVER && getNetworkStream()->isUserMasterServer( it->first )
+         recieverType == RT_SERVER && getNetworkStream()->isUserMasterServer( it->first ) ||
+         recieverType == RT_SERVER && getNetworkStream()->isUserProxyServerActive( it->first )
        )
     {
Index: /trunk/src/lib/network/message_manager.h
===================================================================
--- /trunk/src/lib/network/message_manager.h	(revision 9493)
+++ /trunk/src/lib/network/message_manager.h	(revision 9494)
@@ -26,5 +26,5 @@
 
 
-enum MessageId 
+enum MessageId
 {
   TESTMESSAGEID = 1,
@@ -40,5 +40,5 @@
 enum RecieverType
 {
-  RT_ALL_NOT_ME = 1,   //!< message is sent to all users
+  RT_ALL_BUT_ME = 1,   //!< message is sent to all users but myself
   RT_ALL_ME,           //!< message is sent to all users
   RT_USER,             //!< message is only sent to reciever
@@ -52,5 +52,5 @@
   MP_HIGHBANDWIDTH = 1,  //!< fast and reliable but uses a lot of bandwidth
   MP_LOWBANDWIDTH,       //!< may take a long time to arrive. reliable
-  MP_UNRELIABLE          //!< unreliable. low bandwidth 
+  MP_UNRELIABLE          //!< unreliable. low bandwidth
 };
 
@@ -88,9 +88,9 @@
  public:
    inline static MessageManager * getInstance(){ if (!singletonRef) singletonRef = new MessageManager();  return singletonRef; }
-   
+
    virtual ~MessageManager();
-   
+
    bool registerMessageHandler( MessageId messageId, MessageCallback cb, void * someData );
-   
+
    void sendMessage( MessageId messageId, byte * data, int dataLength, RecieverType recieverType, int reciever, MessagePriority messagePriority );
 
@@ -100,5 +100,5 @@
    virtual void handleSentState( int userId, int stateId, int fromStateId ){}
    virtual void handleRecvState( int userId, int stateId, int fromStateId ){}
-   
+
    void initUser( int userId );
 
@@ -110,5 +110,5 @@
 
    int                       newNumber;              //!< used to create unique message numbers
-   std::list<NetworkMessage> incomingMessageBuffer; 
+   std::list<NetworkMessage> incomingMessageBuffer;
 
 };
Index: /trunk/src/lib/network/monitor/connection_monitor.cc
===================================================================
--- /trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9493)
+++ /trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9494)
@@ -32,5 +32,5 @@
   /* set the class id for the base object and add ist to class list*/
   this->setClassID(CL_CONNECTION_MONITOR, "ConnectionMonitor");
-  
+
   this->userId = userId;
   this->ping = 0;
@@ -43,5 +43,5 @@
   this->nZIncomingPackets = 0;
   this->nZOutgoingPackets = 0;
-  
+
   this->lastPacketTick = 0;
   this->lastPrintTick = 0;
@@ -64,21 +64,21 @@
 {
   nOutgoingPackets++;
-  
+
   // for ping calculation
   sentStateTicks[stateId] = tick;
-  
+
   // calculate bandwidth
   outgoingUnzippedPacketHistory[tick] = length;
   outgoingUnzippedBandWidth = calculateBandWidth( outgoingUnzippedPacketHistory, tick );
-  
+
   //NETPRINTF(n)("UNZIPPED UPSTREAM: user: %d bandwidth %f\n", userId, outgoingUnzippedBandWidth );
-  
+
   // count zero bytes
   //int nZeroBytes = 0;
-  
+
   //for ( int i = 0; i < length; i++ )
   //  if ( data[i] == '\0' )
   //    nZeroBytes++;
-  
+
   //NETPRINTF(n)( "ZEROBYTES: %d (%f%%)\n", nZeroBytes, ((float)100)*nZeroBytes/length );
 }
@@ -94,7 +94,7 @@
 {
   nIncomingPackets++;
-  
+
   lastPacketTick = tick;
-  
+
   // calculate ping
   if ( sentStateTicks.find( ackedState ) != sentStateTicks.end() )
@@ -102,35 +102,35 @@
     ackDelay.push_back( tick - sentStateTicks[ackedState] );
   }
-  
+
   while ( sentStateTicks.begin() != sentStateTicks.end() && sentStateTicks.begin()->first <= ackedState )
     sentStateTicks.erase( sentStateTicks.begin() );
-      
+
   while ( ackDelay.size() > N_PACKETS_FOR_PING )
     ackDelay.erase( ackDelay.begin() );
-      
+
   ping = 0;
-      
+
   for ( std::list<int>::iterator it = ackDelay.begin(); it != ackDelay.end(); it++ )
     ping += *it;
-      
+
   if ( ackDelay.size() == 0 )
     ping = -1;
   else
     ping /= ackDelay.size();
-      
+
   //NETPRINTF(n)("PING: user: %d ping: %d\n", userId, ping );
-  
+
   // calculate bandwidth
   incomingUnzippedPacketHistory[tick] = length;
   incomingUnzippedBandWidth = calculateBandWidth( incomingUnzippedPacketHistory, tick );
-  
+
   //NETPRINTF(n)("UNZIPPED DOWNSTREAM: user: %d bandwidth %f\n", userId, incomingUnzippedBandWidth );
-  
+
 }
 
 /**
  * remove old packets
- * @param packetHistory 
- * @param tick 
+ * @param packetHistory
+ * @param tick
  */
 void ConnectionMonitor::removeOldPackets( std::map< int, int > & packetHistory, int tick )
@@ -149,5 +149,5 @@
 {
   removeOldPackets( packetHistory, tick );
-  
+
   float res = 0.0f;
 #if 0
@@ -157,23 +157,23 @@
       res += it->second;
   }
-  
+
   if ( packetHistory.size() <= 1 || tick - packetHistory.begin()->first == 0 )
     res = 0.0f;
   else
     res /= (float)(tick - packetHistory.begin()->first);
-  
+
   res *= 1000.0f;
 #endif
 
-  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  for ( std::map<int,int>::const_iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
   {
     res += it->second;
   }
-  
+
   if ( packetHistory.size() <= 1 )
     res = 0.0f;
   else
     res /= (float)(tick - packetHistory.begin()->first);
-  
+
   res *= 1000.0f;
 
@@ -191,9 +191,9 @@
 {
   nZOutgoingPackets++;
-  
+
   // calculate bandwidth
   outgoingZippedPacketHistory[tick] = length;
   outgoingZippedBandWidth = calculateBandWidth( outgoingZippedPacketHistory, tick );
-  
+
   //NETPRINTF(n)("UPSTREAM: user: %d bandwidth %f nOutgoingPackets %d\n", userId, outgoingZippedBandWidth, nOutgoingPackets );
 
@@ -216,11 +216,11 @@
 {
   nZIncomingPackets++;
-  
+
   // calculate bandwidth
   incomingZippedPacketHistory[tick] = length;
   incomingZippedBandWidth = calculateBandWidth( incomingZippedPacketHistory, tick );
-  
+
   //NETPRINTF(n)("DOWNSTREAM: user: %d bandwidth %f nIncomingPackets %d\n", userId, incomingZippedBandWidth, nIncomingPackets );
-  
+
 }
 
@@ -230,12 +230,12 @@
  * @return true if last packet recieved \< NOW() - SECS_TO_TIMEOUT
  */
-bool ConnectionMonitor::hasTimedOut( )
+bool ConnectionMonitor::hasTimedOut( ) const
 {
   if ( lastPacketTick + SECS_TO_TIMEOUT*1000 < SDL_GetTicks() && nIncomingPackets > 0 )
     return true;
-  
+
   if ( nIncomingPackets == 0 && nOutgoingPackets >= NETWORK_FREQUENCY*SECS_TO_TIMEOUT )
     return true;
-  
+
   return false;
 }
@@ -246,5 +246,5 @@
  * prints bandwith usage, ping and other important things to telnet-console
  */
-void ConnectionMonitor::printStatis( )
+void ConnectionMonitor::printStatis( ) const
 {
   NETPRINT(n)("============NETWORKSTATS FOR USER %d============\n", userId);
Index: /trunk/src/lib/network/monitor/connection_monitor.h
===================================================================
--- /trunk/src/lib/network/monitor/connection_monitor.h	(revision 9493)
+++ /trunk/src/lib/network/monitor/connection_monitor.h	(revision 9494)
@@ -31,7 +31,11 @@
     void calculatePing();
 
-    bool hasTimedOut();
+    bool hasTimedOut() const;
 
-    void printStatis();
+    void printStatis() const;
+    float getIncomingUnzippedBandWidth() const { return incomingUnzippedBandWidth; }
+    float getOutgoingUnzippedBandWidth() const { return outgoingUnzippedBandWidth; }
+    float getIncomingZippedBandWidth() const { return incomingZippedBandWidth; }
+    float getOutgoingZippedBandWidth() const { return outgoingZippedBandWidth; }
 
   private:
Index: /trunk/src/lib/network/monitor/network_monitor.cc
===================================================================
--- /trunk/src/lib/network/monitor/network_monitor.cc	(revision 9493)
+++ /trunk/src/lib/network/monitor/network_monitor.cc	(revision 9494)
@@ -31,6 +31,8 @@
 
 
-SHELL_COMMAND(showGUI, NetworkMonitor, showGUI);
-SHELL_COMMAND(hideGUI, NetworkMonitor, hideGUI);
+#include "network_stats_widget.h"
+
+SHELL_COMMAND(gui, NetworkMonitor, toggleGUI)
+ ->setAlias("ProxyGui");
 SHELL_COMMAND(debug, NetworkMonitor, debug);
 
@@ -57,11 +59,11 @@
   {
     // assuming that the config files are already read we get the proxy servers
-    std::vector<IPaddress*>* proxyList = NetworkSettings::getInstance()->getProxyList();
-    std::vector<IPaddress*>::iterator it = proxyList->begin();
+    std::vector<IP>* proxyList = NetworkSettings::getInstance()->getProxyList();
+    std::vector<IP>::iterator it = proxyList->begin();
     // create a peer info class and a network node class for each new proxy and add them to the passive list
     for(; it < proxyList->end(); it++)
     {
       PeerInfo* peer = new PeerInfo();
-      peer->ip = *(*it);
+      peer->ip = (*it);
       peer->nodeType = NET_PROXY_SERVER_ACTIVE;
       peer->userId = -1;
@@ -72,4 +74,5 @@
     }
   }
+  this->box = NULL;
 }
 
@@ -119,5 +122,5 @@
  * @param ip ip of the new node
  */
-void NetworkMonitor::addNode(IP ip, int nodeType)
+void NetworkMonitor::addNode(const IP& ip, int nodeType)
 {
   PeerInfo* pInfo = new PeerInfo();
@@ -140,5 +143,5 @@
   if( pInfo->isClient())
     this->localNode->addClient(pInfo);
-  else if( pInfo->isProxyServer())
+  else if( pInfo->isProxyServerActive())
   {
     this->localNode->addActiveProxyServer(pInfo);
@@ -166,5 +169,5 @@
   if( pInfo->isClient())
     node->addClient(pInfo);
-  else if( pInfo->isProxyServer())
+  else if( pInfo->isProxyServerActive())
     node->addActiveProxyServer(pInfo);
   else if( pInfo->isMasterServer())
@@ -176,5 +179,5 @@
  * @returns the proxy server of the first choice
  */
-PeerInfo* NetworkMonitor::getFirstChoiceProxy()
+PeerInfo* NetworkMonitor::getFirstChoiceProxy() const
 {
   // return the fist proxy in the list
@@ -186,5 +189,5 @@
  * @returns the proxy server of second choice
  */
-PeerInfo* NetworkMonitor::getSecondChoiceProxy()
+PeerInfo* NetworkMonitor::getSecondChoiceProxy() const
 {
   // return the second server in the list
@@ -196,5 +199,5 @@
  * this displays the network monitor gui
  */
-void NetworkMonitor::showGUI()
+void NetworkMonitor::toggleGUI()
 {
   if (this->box == NULL)
@@ -202,36 +205,18 @@
     this->box = new OrxGui::GLGuiBox(OrxGui::Vertical);
     {
-      OrxGui::GLGuiBox* waterColorBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
-      {
-        OrxGui::GLGuiText* waterColorText = new OrxGui::GLGuiText();
-        waterColorText->setText("NetworkMonitor");
-        waterColorBox->pack(waterColorText);
-      }
-      this->box->pack(waterColorBox);
+      NetworkStatsWidget* netStats = new NetworkStatsWidget(this);
+      this->box->pack(netStats);
+
     }
 
     this->box->showAll();
     this->box->setAbsCoor2D(300, 40);
-    OrxGui::GLGuiHandler::getInstance()->activate();
-//     OrxGui::GLGuiHandler::getInstance()->activateCursor();
-  }
-}
-
-
-/**
- * hides the network monitor gui again
- */
-void NetworkMonitor::hideGUI()
-{
-  if( this->box == NULL)
-    return;
-
-  OrxGui::GLGuiHandler::getInstance()->deactivate();
-//   OrxGui::GLGuiHandler::getInstance()->deactivateCursor();
-
-  delete this->box;
-  this->box = NULL;
-}
-
+  }
+  else
+  {
+    delete this->box;
+    this->box = NULL;
+  }
+}
 
 /**
@@ -255,12 +240,13 @@
  * prints out the debug informations
  */
-void NetworkMonitor::debug()
+void NetworkMonitor::debug() const
 {
   PRINT(0)("================================= Network Monitor::debug() =====\n");
   PRINT(0)(" I am: %s\n", this->localNode->getPeerInfo()->getNodeTypeString().c_str());
-  PRINT(0)(" Total count of network connections: %i\n", this->playerNumber);
+  PRINT(0)(" Total count of network connections: %i\n", this->connectionNumber);
+  PRINT(0)(" Total count of players: %i\n", this->playerNumber);
   PRINT(0)(" Max players on this server: %i\n", SharedNetworkData::getInstance()->getMaxPlayer());
 
-  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  std::list<NetworkNode*>::const_iterator it = this->nodeList.begin();
   for(; it != this->nodeList.end(); it++)
   {
Index: /trunk/src/lib/network/monitor/network_monitor.h
===================================================================
--- /trunk/src/lib/network/monitor/network_monitor.h	(revision 9493)
+++ /trunk/src/lib/network/monitor/network_monitor.h	(revision 9494)
@@ -37,5 +37,5 @@
 
     void addNode(PeerInfo* pInfo);
-    void addNode(IP ip, int nodeType);
+    void addNode(const IP& ip, int nodeType);
     void addNode(NetworkNode* node) { this->nodeList.push_back(node); }
     void addNode(NetworkNode* node, PeerInfo* pInfo);
@@ -55,28 +55,30 @@
     inline void removeMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->removeMasterServer(pInfo); }
 
-    PeerInfo* getFirstChoiceProxy();
-    PeerInfo* getSecondChoiceProxy();
+    PeerInfo* getFirstChoiceProxy() const;
+    PeerInfo* getSecondChoiceProxy() const;
+    /** @returns the local node */
+    inline NetworkNode* getLocalNode() const { return this->localNode; };
 
     /** @returns the active proxy server list of the localnode */
-    inline std::list<PeerInfo*> getActiveProxyServer() { return this->localNode->getActiveProxyServer(); }
+    inline std::list<PeerInfo*> getActiveProxyServer() const { return this->localNode->getActiveProxyServer(); }
 
     /* slots admin and info interface */
     /** @returns the total number of players in this game (including all proxy servers etc)*/
-    inline int getPlayerNumber() { return this->playerNumber; }
+    inline int getPlayerNumber() const { return this->playerNumber; }
 
     /** @returns true if there are still free network slots available at the local node*/
-    inline bool gotFreeSlots() { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool gotFreeSlots() const { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer()); }
     /** @param node node to be checked for slots @returns true if there are still free network slots available at this node */
-    inline bool gotFreeSlots(NetworkNode* node) { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool gotFreeSlots(NetworkNode* node) const { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer()); }
 
     /** @returns true if the next client should be reconnected to some other proxy server with more connections */
-    inline bool isReconnectNextClient() { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    inline bool isReconnectNextClient() const { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer()); }
 
+    inline const std::list<NetworkNode*>& getNodeList() const { return this->nodeList; };
 
-    void showGUI();
-    void hideGUI();
+    void toggleGUI();
 
     void process();
-    void debug();
+    void debug() const;
 
 
Index: /trunk/src/lib/network/monitor/network_node.cc
===================================================================
--- /trunk/src/lib/network/monitor/network_node.cc	(revision 9493)
+++ /trunk/src/lib/network/monitor/network_node.cc	(revision 9494)
@@ -152,10 +152,10 @@
  * @return the client in the list or NULL if none
  */
-PeerInfo* NetworkNode::getClient(int index)
+PeerInfo* NetworkNode::getClient(int index) const
 {
   if( this->clientList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->clientList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->clientList.begin();
   for(int i = 0; it != this->clientList.end(); it++, i++)
   {
@@ -172,10 +172,10 @@
  * @return the active proxy server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getActiveProxyServer(int index)
+PeerInfo* NetworkNode::getActiveProxyServer(int index) const
 {
   if( this->activeProxyServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->activeProxyServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->activeProxyServerList.begin();
   for(int i = 0; it != this->activeProxyServerList.end(); it++, i++)
   {
@@ -192,10 +192,10 @@
  * @return the passive proxy server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getPassiveProxyServer(int index)
+PeerInfo* NetworkNode::getPassiveProxyServer(int index) const
 {
   if( this->passiveProxyServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->passiveProxyServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->passiveProxyServerList.begin();
   for(int i = 0; it != this->passiveProxyServerList.end(); it++, i++)
   {
@@ -212,10 +212,10 @@
  * @return the master server in the list or NULL if none
  */
-PeerInfo* NetworkNode::getMasterServer(int index)
+PeerInfo* NetworkNode::getMasterServer(int index) const
 {
   if( this->masterServerList.size() < index)
     return NULL;
 
-  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->masterServerList.begin();
   for(int i = 0; it != this->masterServerList.end(); it++, i++)
   {
@@ -232,10 +232,10 @@
  * @param depth: depth in the tree
  */
-void NetworkNode::debug(int depth)
+void NetworkNode::debug(int depth) const
 {
   PRINT(0)(" = %s\n", this->peerInfo->getNodeTypeString().c_str());
 
   PRINT(0)("    master servers: %i\n", this->masterServerList.size());
-  std::list<PeerInfo*>::iterator it = this->masterServerList.begin();
+  std::list<PeerInfo*>::const_iterator it = this->masterServerList.begin();
   for(; it != this->masterServerList.end(); it++)
   {
